libstdc++: std::basic_ios< _CharT, _Traits > Class Template Reference

libstdc++

std::basic_ios< _CharT, _Traits > Class Template Reference
I/O

`#include <basic_ios.h>`

Inheritance diagram for std::basic_ios< _CharT, _Traits >:
[legend]

## Public Types
enum | event { erase_event , imbue_event , copyfmt_event }
typedef void(* | event_callback) (event __e, ios_base &__b, int __i)
typedef _Ios_Fmtflags | fmtflags
typedef _Ios_Iostate | iostate
typedef _Ios_Openmode | openmode
typedef _Ios_Seekdir | seekdir
typedef _CharT | char_type
typedef _Traits::int_type | int_type
typedef _Traits::pos_type | pos_type
typedef _Traits::off_type | off_type
typedef _Traits | traits_type
typedef ctype< _CharT > | __ctype_type
typedef num_put< _CharT, ostreambuf_iterator< _CharT, _Traits > > | __num_put_type
typedef num_get< _CharT, istreambuf_iterator< _CharT, _Traits > > | __num_get_type

## Public Member Functions
| basic_ios (basic_streambuf< _CharT, _Traits > *__sb)
virtual | ~basic_ios ()
const locale & | _M_getloc () const
void | _M_setstate (iostate __state)
bool | bad () const
void | clear (iostate __state=goodbit)
basic_ios & | copyfmt (const basic_ios &__rhs)
bool | eof () const
iostate | exceptions () const
void | exceptions (iostate __except)
bool | fail () const
char_type | fill () const
char_type | fill (char_type __ch)
fmtflags | flags () const
fmtflags | flags (fmtflags __fmtfl)
locale | getloc () const
bool | good () const
locale | imbue (const locale &__loc)
long & | iword (int __ix)
char | narrow (char_type __c, char __dfault) const
streamsize | precision () const
streamsize | precision (streamsize __prec)
void *& | pword (int __ix)
basic_streambuf< _CharT, _Traits > * | rdbuf () const
basic_streambuf< _CharT, _Traits > * | rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
iostate | rdstate () const
void | register_callback (event_callback __fn, int __index)
fmtflags | setf (fmtflags __fmtfl)
fmtflags | setf (fmtflags __fmtfl, fmtflags __mask)
void | setstate (iostate __state)
basic_ostream< _CharT, _Traits > * | tie () const
basic_ostream< _CharT, _Traits > * | tie (basic_ostream< _CharT, _Traits > *__tiestr)
void | unsetf (fmtflags __mask)
char_type | widen (char __c) const
streamsize | width () const
streamsize | width (streamsize __wide)
| operator bool () const
bool | operator! () const

## Static Public Member Functions
static bool | sync_with_stdio (bool __sync=true)
static int | xalloc () throw ()

## Static Public Attributes
static const openmode | __noreplace
static const fmtflags | adjustfield
static const openmode | app
static const openmode | ate
static const iostate | badbit
static const fmtflags | basefield
static const seekdir | beg
static const openmode | binary
static const fmtflags | boolalpha
static const seekdir | cur
static const fmtflags | dec
static const seekdir | end
static const iostate | eofbit
static const iostate | failbit
static const fmtflags | fixed
static const fmtflags | floatfield
static const iostate | goodbit
static const fmtflags | hex
static const openmode | in
static const fmtflags | internal
static const fmtflags | left
static const fmtflags | oct
static const openmode | out
static const fmtflags | right
static const fmtflags | scientific
static const fmtflags | showbase
static const fmtflags | showpoint
static const fmtflags | showpos
static const fmtflags | skipws
static const openmode | trunc
static const fmtflags | unitbuf
static const fmtflags | uppercase

## Protected Types
enum | { _S_local_word_size }

## Protected Member Functions
| basic_ios ()
| basic_ios (const basic_ios &)=delete
void | _M_cache_locale (const locale &__loc)
void | _M_call_callbacks (event __ev) throw ()
void | _M_dispose_callbacks (void) throw ()
_Words & | _M_grow_words (int __index, bool __iword)
void | _M_init () throw ()
void | _M_move (ios_base &) noexcept
void | _M_swap (ios_base &__rhs) noexcept
void | init (basic_streambuf< _CharT, _Traits > *__sb)
void | move (basic_ios &&__rhs)
void | move (basic_ios &__rhs)
basic_ios & | operator= (const basic_ios &)=delete
void | set_rdbuf (basic_streambuf< _CharT, _Traits > *__sb)
void | swap (basic_ios &__rhs) noexcept

## Protected Attributes
_Callback_list * | _M_callbacks
const __ctype_type * | _M_ctype
iostate | _M_exception
char_type | _M_fill
bool | _M_fill_init
fmtflags | _M_flags
locale | _M_ios_locale
_Words | _M_local_word [_S_local_word_size]
const __num_get_type * | _M_num_get
const __num_put_type * | _M_num_put
streamsize | _M_precision
basic_streambuf< _CharT, _Traits > * | _M_streambuf
iostate | _M_streambuf_state
basic_ostream< _CharT, _Traits > * | _M_tie
streamsize | _M_width
_Words * | _M_word
int | _M_word_size
_Words | _M_word_zero

## Detailed Description

template<typename _CharT, typename _Traits>
class std::basic_ios< _CharT, _Traits >

Template class basic_ios, virtual base class for all stream classes.

Template Parameters

  _CharT | Type of character stream.
  _Traits | Traits for character type, defaults to char_traits<_CharT>.

Most of the member functions called dispatched on stream objects (e.g., `std::cout.foo(bar)`;) are consolidated in this class.

Definition at line 70 of file basic_ios.h.

## Member Typedef Documentation

## ◆ __ctype_type

template<typename _CharT, typename _Traits>

typedef ctype<_CharT> std::basic_ios< _CharT, _Traits >::__ctype_type

These are non-standard types.

Definition at line 94 of file basic_ios.h.

## ◆ __num_get_type

template<typename _CharT, typename _Traits>

typedef num_get<_CharT, istreambuf_iterator<_CharT, _Traits> > std::basic_ios< _CharT, _Traits >::__num_get_type

These are non-standard types.

Definition at line 98 of file basic_ios.h.

## ◆ __num_put_type

template<typename _CharT, typename _Traits>

typedef num_put<_CharT, ostreambuf_iterator<_CharT, _Traits> > std::basic_ios< _CharT, _Traits >::__num_put_type

These are non-standard types.

Definition at line 96 of file basic_ios.h.

## ◆ char_type

template<typename _CharT, typename _Traits>

typedef _CharT std::basic_ios< _CharT, _Traits >::char_type

These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 83 of file basic_ios.h.

## ◆ event_callback

typedef void(* std::ios_base::event_callback) (event __e, ios_base &__b, int __i)
| inherited

The type of an event callback function.

Parameters

  __e | One of the members of the event enum.
  __b | Reference to the ios_base object.
  __i | The integer provided when the callback was registered.

Event callbacks are user defined functions that get called during several ios_base and basic_ios functions, specifically imbue(), copyfmt(), and ~ios().

Definition at line 573 of file ios_base.h.

## ◆ fmtflags

typedef _Ios_Fmtflags std::ios_base::fmtflags
| inherited

This is a bitmask type.

`_Ios_Fmtflags is` implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type fmtflags are:

- boolalpha
- dec
- fixed
- hex
- internal
- left
- oct
- right
- scientific
- showbase
- showpoint
- showpos
- skipws
- unitbuf
- uppercase
- adjustfield
- basefield
- floatfield

Definition at line 378 of file ios_base.h.

## ◆ int_type

template<typename _CharT, typename _Traits>

typedef _Traits::int_type std::basic_ios< _CharT, _Traits >::int_type

These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 84 of file basic_ios.h.

## ◆ iostate

typedef _Ios_Iostate std::ios_base::iostate
| inherited

This is a bitmask type.

`_Ios_Iostate is` implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type iostate are:

- badbit
- eofbit
- failbit
- goodbit

Definition at line 453 of file ios_base.h.

## ◆ off_type

template<typename _CharT, typename _Traits>

typedef _Traits::off_type std::basic_ios< _CharT, _Traits >::off_type

These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 86 of file basic_ios.h.

## ◆ openmode

typedef _Ios_Openmode std::ios_base::openmode
| inherited

This is a bitmask type.

`_Ios_Openmode is` implementation-defined, but it is valid to perform bitwise operations on these values and expect the Right Thing to happen. Defined objects of type openmode are:

- app
- ate
- binary
- in
- out
- trunc

Definition at line 484 of file ios_base.h.

## ◆ pos_type

template<typename _CharT, typename _Traits>

typedef _Traits::pos_type std::basic_ios< _CharT, _Traits >::pos_type

These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 85 of file basic_ios.h.

## ◆ seekdir

typedef _Ios_Seekdir std::ios_base::seekdir
| inherited

This is an enumerated type.

`_Ios_Seekdir is` implementation-defined. Defined values of type seekdir are:

- beg
- cur, equivalent to `SEEK_CUR` in the C standard library.
- end, equivalent to `SEEK_END` in the C standard library.

Definition at line 523 of file ios_base.h.

## ◆ traits_type

template<typename _CharT, typename _Traits>

typedef _Traits std::basic_ios< _CharT, _Traits >::traits_type

These are standard types. They permit a standardized way of referring to names of (or names dependent on) the template parameters, which are specific to the implementation.

Definition at line 87 of file basic_ios.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| protected inherited

Definition at line 648 of file ios_base.h.

## ◆ event

enum std::ios_base::event
| inherited

The set of events that may be passed to an event callback.

erase_event is used during ~ios() and copyfmt(). imbue_event is used during imbue(). copyfmt_event is used during copyfmt().

Definition at line 556 of file ios_base.h.

## Constructor & Destructor Documentation

## ◆ basic_ios() [1/2]

template<typename _CharT, typename _Traits>

std::basic_ios< _CharT, _Traits >::basic_ios | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) |
| inline explicit

Constructor performs initialization.

The parameter is passed by derived streams.

Definition at line 285 of file basic_ios.h.

Referenced by copyfmt().

## ◆ ~basic_ios()

template<typename _CharT, typename _Traits>

virtual std::basic_ios< _CharT, _Traits >::~basic_ios | ( |  | ) |
| inline virtual

Empty.

The destructor does nothing. More specifically, it does not destroy the streambuf held by rdbuf().

Definition at line 297 of file basic_ios.h.

## ◆ basic_ios() [2/2]

template<typename _CharT, typename _Traits>

std::basic_ios< _CharT, _Traits >::basic_ios | ( |  | ) |
| inline protected

Empty.

The default constructor does nothing and is not normally accessible to users.

Definition at line 476 of file basic_ios.h.

## Member Function Documentation

## ◆ _M_cache_locale()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::_M_cache_locale | ( | const locale & | __loc | ) |
| protected

Definition at line 169 of file basic_ios.tcc.

## ◆ _M_getloc()

const locale & std::ios_base::_M_getloc | ( |  | ) | const
| inline inherited

Locale access.

Returns
  A reference to the current locale.

Like getloc above, but returns a reference instead of generating a copy.

Definition at line 852 of file ios_base.h.

Referenced by std::money_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::num_put< _CharT, _OutIter >::do_put(), std::time_put< _CharT, _OutIter >::do_put(), std::time_get< _CharT, _InIter >::get(), and std::time_put< _CharT, _OutIter >::put().

## ◆ _M_setstate()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::_M_setstate | ( | iostate | __state | ) |
| inline

Definition at line 174 of file basic_ios.h.

## ◆ bad()

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::bad | ( |  | ) | const
| inline nodiscard

Fast error checking.

Returns
  True if the badbit is set.

Note that other iostate flags may also be set.

Definition at line 225 of file basic_ios.h.

Referenced by std::basic_ostream< _CharT, _Traits >::sentry::sentry().

## ◆ clear()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::clear | ( | iostate | __state = goodbit | ) |

[Re]sets the error state.

Parameters

  __state | The new state flag(s) to set.

See std::ios_base::iostate for the possible bit values. Most users will not need to pass an argument.

Definition at line 46 of file basic_ios.tcc.

References std::ios_base::badbit, exceptions(), rdbuf(), and rdstate().

Referenced by std::basic_ios< char_type, traits_type >::exceptions(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::__detail::operator>>(), std::basic_istream< _CharT, _Traits >::putback(), rdbuf(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ios< char_type, traits_type >::setstate(), and std::basic_istream< _CharT, _Traits >::unget().

## ◆ copyfmt()

template<typename _CharT, typename _Traits>

basic_ios< _CharT, _Traits > & std::basic_ios< _CharT, _Traits >::copyfmt | ( | const basic_ios< _CharT, _Traits > & | __rhs | ) |

Copies fields of __rhs into this.

Parameters

  __rhs | The source values for the copies.

Returns
  Reference to this object.

All fields of __rhs are copied into this object except that rdbuf() and rdstate() remain unchanged. All values in the pword and iword arrays are copied. Before copying, each callback is invoked with erase_event. After copying, each (new) callback is invoked with copyfmt_event. The final step is to copy exceptions().

Definition at line 68 of file basic_ios.tcc.

References basic_ios(), std::__addressof(), exceptions(), fill(), std::ios_base::flags(), std::ios_base::getloc(), std::ios_base::precision(), tie(), std::tie(), and std::ios_base::width().

## ◆ eof()

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::eof | ( |  | ) | const
| inline nodiscard

Fast error checking.

Returns
  True if the eofbit is set.

Note that other iostate flags may also be set.

Definition at line 202 of file basic_ios.h.

## ◆ exceptions() [1/2]

template<typename _CharT, typename _Traits>

iostate std::basic_ios< _CharT, _Traits >::exceptions | ( |  | ) | const
| inline nodiscard

Throwing exceptions on errors.

Returns
  The current exceptions mask.

This changes nothing in the stream. See the one-argument version of exceptions(iostate) for the meaning of the return value.

Definition at line 237 of file basic_ios.h.

Referenced by clear(), and copyfmt().

## ◆ exceptions() [2/2]

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::exceptions | ( | iostate | __except | ) |
| inline

Throwing exceptions on errors.

Parameters

  __except | The new exceptions mask.

By default, error flags are set silently. You can set an exceptions mask for each stream; if a bit in the mask becomes set in the error flags, then an exception of type std::ios_base::failure is thrown.

If the error flag is already set when the exceptions mask is added, the exception is immediately thrown. Try running the following under GCC 3.1 or later:

#include <iostream>
#include <fstream>
#include <exception>
int main()
{
std::set_terminate (__gnu_cxx::__verbose_terminate_handler);
std::ifstream f ("/etc/motd");
std::cerr << "Setting badbit\n";
f.setstate (std::ios_base::badbit);
std::cerr << "Setting exception mask\n";
f.exceptions (std::ios_base::badbit);
}
exception
fstream
iostream
std::ifstream
basic_ifstream< char > ifstream
Class for char input file streams.
Definition iosfwd_file.h:65
std::set_terminate
terminate_handler set_terminate(terminate_handler) noexcept
Takes a new handler function as an argument, returns the old function.
__gnu_cxx::__verbose_terminate_handler
void __verbose_terminate_handler()
A replacement for the standard terminate_handler which prints more information about the terminating ...
std::cerr
ostream cerr
Linked to standard error (unbuffered).
std::ios_base::badbit
static const iostate badbit
Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error fro...
Definition ios_base.h:457

Definition at line 272 of file basic_ios.h.

## ◆ fail()

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::fail | ( |  | ) | const
| inline nodiscard

Fast error checking.

Returns
  True if either the badbit or the failbit is set.

Checking the badbit in fail() is historical practice. Note that other iostate flags may also be set.

Definition at line 214 of file basic_ios.h.

Referenced by std::basic_ios< char_type, traits_type >::operator bool(), std::basic_ios< char_type, traits_type >::operator!(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::tellg(), and std::basic_ostream< _CharT, _Traits >::tellp().

## ◆ fill() [1/2]

template<typename _CharT, typename _Traits>

char_type std::basic_ios< _CharT, _Traits >::fill | ( |  | ) | const
| inline nodiscard

Retrieves the empty character.

Returns
  The current fill character.

It defaults to a space (' ') in the current locale.

Definition at line 388 of file basic_ios.h.

Referenced by copyfmt(), and std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator<<.

## ◆ fill() [2/2]

template<typename _CharT, typename _Traits>

char_type std::basic_ios< _CharT, _Traits >::fill | ( | char_type | __ch | ) |
| inline

Sets a new empty character.

Parameters

  __ch | The new character.

Returns
  The previous fill character.

The fill character is used to fill out space when P+ characters have been requested (e.g., via setw), Q characters are actually used, and Q<P. It defaults to a space (' ') in the current locale.

Definition at line 405 of file basic_ios.h.

## ◆ flags() [1/2]

fmtflags std::ios_base::flags | ( |  | ) | const
| inline nodiscard inherited

Access to format flags.

Returns
  The format control flags for both input and output.

Definition at line 694 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), std::num_put< _CharT, _OutIter >::do_put(), std::chrono::operator<<(), std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator<<, std::__detail::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), and std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator>>.

## ◆ flags() [2/2]

fmtflags std::ios_base::flags | ( | fmtflags | __fmtfl | ) |
| inline inherited

Setting new format flags all at once.

Parameters

  __fmtfl | The new flags to set.

Returns
  The previous format control flags.

This function overwrites all the format flags with __fmtfl.

Definition at line 705 of file ios_base.h.

## ◆ getloc()

locale std::ios_base::getloc | ( |  | ) | const
| inline nodiscard inherited

Locale access.

Returns
  A copy of the current locale.

If `imbue(loc)` has previously been called, then this function returns `loc`. Otherwise, it returns a copy of `std::locale()`, the global C++ locale.

Definition at line 841 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::money_put< _CharT, _OutIter >::do_put(), std::basic_ios< _CharT, _Traits >::imbue(), std::chrono::operator<<(), std::operator>>(), std::operator>>(), and std::ws().

## ◆ good()

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::good | ( |  | ) | const
| inline nodiscard

Fast error checking.

Returns
  True if no error flags are set.

A wrapper around rdstate.

Definition at line 191 of file basic_ios.h.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::basic_ostream< _CharT, _Traits >::sentry::sentry(), and std::__detail::operator>>().

## ◆ imbue()

template<typename _CharT, typename _Traits>

locale std::basic_ios< _CharT, _Traits >::imbue | ( | const locale & | __loc | ) |

Moves to a new locale.

Parameters

  __loc | The new locale.

Returns
  The previous locale.

Calls `ios_base::imbue(loc)`, and if a stream buffer is associated with this stream, calls that buffer's `pubimbue(loc)`.

Additional l10n notes are at https://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Definition at line 119 of file basic_ios.tcc.

References std::ios_base::getloc(), std::ios_base::imbue(), and rdbuf().

Referenced by std::chrono::operator<<().

## ◆ init()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::init | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) |
| protected

All setup is performed here.

This is called from the public constructor. It is not virtual and cannot be redefined.

Definition at line 131 of file basic_ios.tcc.

Referenced by std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_ios< char_type, traits_type >::basic_ios(), std::basic_istream< char_type, traits_type >::basic_istream(), std::basic_istringstream< char >::basic_istringstream(), std::basic_istringstream< char >::basic_istringstream(), std::basic_istringstream< char >::basic_istringstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ostream< char_type, traits_type >::basic_ostream(), std::basic_ostringstream< char >::basic_ostringstream(), std::basic_ostringstream< char >::basic_ostringstream(), std::basic_ostringstream< char >::basic_ostringstream(), std::basic_stringstream< char >::basic_stringstream(), std::basic_stringstream< char >::basic_stringstream(), and std::basic_stringstream< char >::basic_stringstream().

## ◆ iword()

long & std::ios_base::iword | ( | int | __ix | ) |
| inline inherited

Access to integer array.

Parameters

  __ix | Index into the array.

Returns
  A reference to an integer associated with the index.

The iword function provides access to an array of integers that can be used for any purpose. The array grows as required to hold the supplied index. All integers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 887 of file ios_base.h.

References iword().

Referenced by iword().

## ◆ move() [1/2]

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::move | ( | basic_ios< _CharT, _Traits > && | __rhs | ) |
| inline protected

Definition at line 506 of file basic_ios.h.

## ◆ move() [2/2]

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::move | ( | basic_ios< _CharT, _Traits > & | __rhs | ) |
| inline protected

Definition at line 495 of file basic_ios.h.

## ◆ narrow()

template<typename _CharT, typename _Traits>

char std::basic_ios< _CharT, _Traits >::narrow | ( | char_type | __c,
|  | char | __dfault ) const
| inline

Squeezes characters.

Parameters

  __c | The character to narrow.
  __dfault | The character to narrow.

Returns
  The narrowed character.

Maps a character of `char_type` to a character of `char`, if possible.

Returns the result of

std::use_facet<ctype<char_type> >(getloc()).narrow(c,dfault)
std::use_facet
const _Facet & use_facet(const locale &__loc)
Return a facet.
Definition locale_classes.tcc:220
std::basic_ios::narrow
char narrow(char_type __c, char __dfault) const
Squeezes characters.
Definition basic_ios.h:446
std::ios_base::getloc
locale getloc() const
Locale access.
Definition ios_base.h:841

Additional l10n notes are at https://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Definition at line 446 of file basic_ios.h.

## ◆ operator bool()

template<typename _CharT, typename _Traits>

std::basic_ios< _CharT, _Traits >::operator bool | ( |  | ) | const
| inline explicit nodiscard

The quick-and-easy status check.

This allows you to write constructs such as `if (!a_stream) ...` and `while (a_stream) ...`

Definition at line 125 of file basic_ios.h.

## ◆ operator!()

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::operator! | ( |  | ) | const
| inline nodiscard

The quick-and-easy status check.

This allows you to write constructs such as `if (!a_stream) ...` and `while (a_stream) ...`

Definition at line 134 of file basic_ios.h.

## ◆ precision() [1/2]

streamsize std::ios_base::precision | ( |  | ) | const
| inline nodiscard inherited

Flags access.

Returns
  The precision to generate on certain output operations.

Be careful if you try to give a definition of precision here; see DR 189.

Definition at line 765 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), and std::chrono::operator<<().

## ◆ precision() [2/2]

streamsize std::ios_base::precision | ( | streamsize | __prec | ) |
| inline inherited

Changing flags.

Parameters

  __prec | The new precision value.

Returns
  The previous value of precision().

Definition at line 774 of file ios_base.h.

## ◆ pword()

void *& std::ios_base::pword | ( | int | __ix | ) |
| inline inherited

Access to void pointer array.

Parameters

  __ix | Index into the array.

Returns
  A reference to a void* associated with the index.

The pword function provides access to an array of pointers that can be used for any purpose. The array grows as required to hold the supplied index. All pointers in the array are initialized to 0.

The implementation reserves several indices. You should use xalloc to obtain an index that is safe to use. Also note that since the array can grow dynamically, it is not safe to hold onto the reference.

Definition at line 908 of file ios_base.h.

## ◆ rdbuf() [1/2]

template<typename _CharT, typename _Traits>

basic_streambuf< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::rdbuf | ( |  | ) | const
| inline nodiscard

Accessing the underlying buffer.

Returns
  The current stream buffer.

This does not change the state of the stream.

Definition at line 338 of file basic_ios.h.

Referenced by clear(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::ignore(), imbue(), std::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::tr2::operator>>(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_ostream< _CharT, _Traits >::tellp(), std::basic_istream< _CharT, _Traits >::unget(), and std::ws().

## ◆ rdbuf() [2/2]

template<typename _CharT, typename _Traits>

basic_streambuf< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::rdbuf | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) |

Changing the underlying buffer.

Parameters

  __sb | The new stream buffer.

Returns
  The previous stream buffer.

Associates a new buffer with the current stream, and clears the error state.

Due to historical accidents which the LWG refuses to correct, the I/O library suffers from a design error: this function is hidden in derived classes by overrides of the zero-argument `rdbuf()`, which is non-virtual for hysterical raisins. As a result, you must use explicit qualifications to access this function via any derived class. For example:

std::fstream foo; // or some other derived type
std::streambuf* p = .....;
foo.ios::rdbuf(p); // ios == basic_ios<char>
std::streambuf
basic_streambuf< char > streambuf
Base class for char buffers.
Definition iosfwd.h:78
std::fstream
basic_fstream< char > fstream
Class for char mixed input and output file streams.
Definition iosfwd_file.h:71

Definition at line 58 of file basic_ios.tcc.

References clear().

## ◆ rdstate()

template<typename _CharT, typename _Traits>

iostate std::basic_ios< _CharT, _Traits >::rdstate | ( |  | ) | const
| inline nodiscard

Returns the error state of the stream buffer.

Returns
  A bit pattern (well, isn't everything?)

See std::ios_base::iostate for the possible bit values. Most users will call one of the interpreting wrappers, e.g., good().

Definition at line 147 of file basic_ios.h.

Referenced by std::basic_ios< char_type, traits_type >::bad(), clear(), std::basic_ios< char_type, traits_type >::eof(), std::basic_ios< char_type, traits_type >::fail(), std::basic_ios< char_type, traits_type >::good(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ios< char_type, traits_type >::setstate(), and std::basic_istream< _CharT, _Traits >::unget().

## ◆ register_callback()

void std::ios_base::register_callback | ( | event_callback | __fn,
|  | int | __index )
| inherited

Add the callback __fn with parameter __index.

Parameters

  __fn | The function to add.
  __index | The integer to pass to the function when invoked.

Registers a function as an event callback with an integer parameter to be passed to the function when invoked. Multiple copies of the function are allowed. If there are multiple callbacks, they are invoked in the order they were registered.

## ◆ set_rdbuf()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::set_rdbuf | ( | basic_streambuf< _CharT, _Traits > * | __sb | ) |
| inline protected

Definition at line 521 of file basic_ios.h.

## ◆ setf() [1/2]

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl | ) |
| inline inherited

Setting new format flags.

Parameters

  __fmtfl | Additional flags to set.

Returns
  The previous format control flags.

This function sets additional flags in format control. Flags that were previously set remain set.

Definition at line 721 of file ios_base.h.

Referenced by std::__detail::operator>>().

## ◆ setf() [2/2]

fmtflags std::ios_base::setf | ( | fmtflags | __fmtfl,
|  | fmtflags | __mask )
| inline inherited

Setting new format flags.

Parameters

  __fmtfl | Additional flags to set.
  __mask | The flags mask for fmtfl.

Returns
  The previous format control flags.

This function clears mask in the format flags, then sets fmtfl `&` mask. An example mask is `ios_base::adjustfield`.

Definition at line 738 of file ios_base.h.

## ◆ setstate()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::setstate | ( | iostate | __state | ) |
| inline

Sets additional flags in the error state.

Parameters

  __state | The additional state flag(s) to set.

See std::ios_base::iostate for the possible bit values.

Definition at line 167 of file basic_ios.h.

Referenced by std::basic_ostream< _CharT, _Traits >::sentry::sentry(), std::basic_fstream< char >::close(), std::basic_ifstream< char >::close(), std::basic_ofstream< char >::close(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::getline(), std::getline(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::operator<<(), std::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::operator>>(), std::operator>>(), std::tr2::operator>>(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::unget(), and std::ws().

## ◆ swap()

template<typename _CharT, typename _Traits>

void std::basic_ios< _CharT, _Traits >::swap | ( | basic_ios< _CharT, _Traits > & | __rhs | ) |
| inline protected noexcept

Definition at line 510 of file basic_ios.h.

## ◆ sync_with_stdio()

bool std::ios_base::sync_with_stdio | ( | bool | __sync = true | ) |
| static inherited

Interaction with the standard C I/O objects.

Parameters

  __sync | Whether to synchronize or not.

Returns
  True if the standard streams were previously synchronized.

The synchronization referred to is only that between the standard C facilities (e.g., stdout) and the standard C++ objects (e.g., cout). User-declared streams are unaffected. See https://gcc.gnu.org/onlinedocs/libstdc++/manual/fstreams.html#std.io.filestreams.binary

## ◆ tie() [1/2]

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::tie | ( |  | ) | const
| inline nodiscard

Fetches the current tied stream.

Returns
  A pointer to the tied stream, or NULL if the stream is not tied.

A stream may be tied (or synchronized) to a second output stream. When this stream performs any I/O, the tied stream is first flushed. For example, `std::cin` is tied to `std::cout`.

Definition at line 311 of file basic_ios.h.

Referenced by std::basic_ostream< _CharT, _Traits >::sentry::sentry(), and copyfmt().

## ◆ tie() [2/2]

template<typename _CharT, typename _Traits>

basic_ostream< _CharT, _Traits > * std::basic_ios< _CharT, _Traits >::tie | ( | basic_ostream< _CharT, _Traits > * | __tiestr | ) |
| inline

Ties this stream to an output stream.

Parameters

  __tiestr | The output stream.

Returns
  The previously tied output stream, or NULL if the stream was not tied.

This sets up a new tie; see tie() for more.

Definition at line 323 of file basic_ios.h.

## ◆ unsetf()

void std::ios_base::unsetf | ( | fmtflags | __mask | ) |
| inline inherited

Clearing format flags.

Parameters

  __mask | The flags to unset.

This function clears __mask in the format flags.

Definition at line 753 of file ios_base.h.

## ◆ widen()

template<typename _CharT, typename _Traits>

char_type std::basic_ios< _CharT, _Traits >::widen | ( | char | __c | ) | const
| inline

Widens characters.

Parameters

  __c | The character to widen.

Returns
  The widened character.

Maps a character of `char` to a character of `char_type`.

Returns the result of

std::use_facet<ctype<char_type> >(getloc()).widen(c)
std::basic_ios::widen
char_type widen(char __c) const
Widens characters.
Definition basic_ios.h:465

Additional l10n notes are at https://gcc.gnu.org/onlinedocs/libstdc++/manual/localization.html

Definition at line 465 of file basic_ios.h.

Referenced by std::endl(), std::basic_ios< char_type, traits_type >::fill(), std::basic_istream< char_type, traits_type >::get(), std::basic_istream< char_type, traits_type >::get(), std::basic_istream< char_type, traits_type >::getline(), std::getline(), std::getline(), std::operator<<(), std::operator<<(), std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator<<, and std::tr2::operator>>().

## ◆ width() [1/2]

streamsize std::ios_base::width | ( |  | ) | const
| inline nodiscard inherited

Flags access.

Returns
  The minimum field width to generate on output operations.

Minimum field width refers to the number of characters.

Definition at line 789 of file ios_base.h.

Referenced by std::basic_ios< _CharT, _Traits >::copyfmt(), std::num_put< _CharT, _OutIter >::do_put(), std::operator>>(), and std::operator>>().

## ◆ width() [2/2]

streamsize std::ios_base::width | ( | streamsize | __wide | ) |
| inline inherited

Changing flags.

Parameters

  __wide | The new width value.

Returns
  The previous value of width().

Definition at line 798 of file ios_base.h.

## ◆ xalloc()

int std::ios_base::xalloc | ( |  | ) |
throw | ( | ) |  |  |
| static inherited

Access to unique indices.

Returns
  An integer different from all previous calls.

This function returns a unique integer every time it is called. It can be used for any purpose, but is primarily intended to be a unique index for the iword and pword functions. The expectation is that an application calls xalloc in order to obtain an index in the iword and pword arrays that can be used without fear of conflict.

The implementation maintains a static variable that is incremented and returned on each invocation. xalloc is guaranteed to return an index that is safe to use in the iword and pword arrays.

## Member Data Documentation

## ◆ __noreplace

const openmode std::ios_base::__noreplace
| static inherited

Definition at line 506 of file ios_base.h.

## ◆ _M_callbacks

_Callback_list* std::ios_base::_M_callbacks
| protected inherited

Definition at line 627 of file ios_base.h.

## ◆ _M_ctype

template<typename _CharT, typename _Traits>

const __ctype_type* std::basic_ios< _CharT, _Traits >::_M_ctype
| protected

Definition at line 109 of file basic_ios.h.

## ◆ _M_exception

iostate std::ios_base::_M_exception
| protected inherited

Definition at line 592 of file ios_base.h.

## ◆ _M_fill

template<typename _CharT, typename _Traits>

char_type std::basic_ios< _CharT, _Traits >::_M_fill
| mutable protected

Definition at line 104 of file basic_ios.h.

## ◆ _M_fill_init

template<typename _CharT, typename _Traits>

bool std::basic_ios< _CharT, _Traits >::_M_fill_init
| mutable protected

Definition at line 105 of file basic_ios.h.

## ◆ _M_flags

fmtflags std::ios_base::_M_flags
| protected inherited

Definition at line 591 of file ios_base.h.

## ◆ _M_ios_locale

locale std::ios_base::_M_ios_locale
| protected inherited

Definition at line 659 of file ios_base.h.

## ◆ _M_local_word

_Words std::ios_base::_M_local_word[_S_local_word_size]
| protected inherited

Definition at line 649 of file ios_base.h.

## ◆ _M_num_get

template<typename _CharT, typename _Traits>

const __num_get_type* std::basic_ios< _CharT, _Traits >::_M_num_get
| protected

Definition at line 113 of file basic_ios.h.

## ◆ _M_num_put

template<typename _CharT, typename _Traits>

const __num_put_type* std::basic_ios< _CharT, _Traits >::_M_num_put
| protected

Definition at line 111 of file basic_ios.h.

## ◆ _M_precision

streamsize std::ios_base::_M_precision
| protected inherited

Definition at line 589 of file ios_base.h.

## ◆ _M_streambuf

template<typename _CharT, typename _Traits>

basic_streambuf<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::_M_streambuf
| protected

Definition at line 106 of file basic_ios.h.

## ◆ _M_streambuf_state

iostate std::ios_base::_M_streambuf_state
| protected inherited

Definition at line 593 of file ios_base.h.

## ◆ _M_tie

template<typename _CharT, typename _Traits>

basic_ostream<_CharT, _Traits>* std::basic_ios< _CharT, _Traits >::_M_tie
| protected

Definition at line 103 of file basic_ios.h.

## ◆ _M_width

streamsize std::ios_base::_M_width
| protected inherited

Definition at line 590 of file ios_base.h.

## ◆ _M_word

_Words* std::ios_base::_M_word
| protected inherited

Definition at line 653 of file ios_base.h.

## ◆ _M_word_size

int std::ios_base::_M_word_size
| protected inherited

Definition at line 652 of file ios_base.h.

## ◆ _M_word_zero

_Words std::ios_base::_M_word_zero
| protected inherited

Definition at line 644 of file ios_base.h.

## ◆ adjustfield

const fmtflags std::ios_base::adjustfield
| static inherited

A mask of left|right|internal. Useful for the 2-arg form of `setf`.

Definition at line 433 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::internal(), std::left(), and std::right().

## ◆ app

const openmode std::ios_base::app
| static inherited

Seek to end before each write.

Definition at line 487 of file ios_base.h.

Referenced by std::basic_filebuf< char_type, traits_type >::_M_set_buffer(), std::basic_filebuf< _CharT, _Traits >::overflow(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

## ◆ ate

const openmode std::ios_base::ate
| static inherited

Open and seek to end immediately after opening.

Definition at line 490 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::open().

## ◆ badbit

const iostate std::ios_base::badbit
| static inherited

Indicates a loss of integrity in an input or output sequence (such as an irrecoverable read error from a file).

Definition at line 457 of file ios_base.h.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::basic_ostream< _CharT, _Traits >::sentry::~sentry(), std::basic_ios< _CharT, _Traits >::clear(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_iostream< char_type, traits_type >::operator<<(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_iostream< char_type, traits_type >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_iostream< char_type, traits_type >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_istream< _CharT, _Traits >::unget(), and std::ws().

## ◆ basefield

const fmtflags std::ios_base::basefield
| static inherited

A mask of dec|oct|hex. Useful for the 2-arg form of `setf`.

Definition at line 436 of file ios_base.h.

Referenced by std::dec(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), std::hex(), and std::oct().

## ◆ beg

const seekdir std::ios_base::beg
| static inherited

Request a seek relative to the beginning of the stream.

Definition at line 526 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::seekpos().

## ◆ binary

const openmode std::ios_base::binary
| static inherited

Perform input and output in binary mode (as opposed to text mode). This is probably not what you think it is; see https://gcc.gnu.org/onlinedocs/libstdc++/manual/fstreams.html#std.io.filestreams.binary.

Definition at line 495 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::showmanyc().

## ◆ boolalpha

const fmtflags std::ios_base::boolalpha
| static inherited

Insert/extract `bool` in alphabetic rather than numeric format.

Definition at line 381 of file ios_base.h.

Referenced by std::boolalpha(), std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::noboolalpha().

## ◆ cur

const seekdir std::ios_base::cur
| static inherited

Request a seek relative to the current position within the sequence.

Definition at line 529 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::imbue(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_filebuf< _CharT, _Traits >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_istream< _CharT, _Traits >::tellg(), and std::basic_ostream< _CharT, _Traits >::tellp().

## ◆ dec

const fmtflags std::ios_base::dec
| static inherited

Converts integer input or generates integer output in decimal base.

Definition at line 384 of file ios_base.h.

Referenced by std::dec(), std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator<<, and std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator>>.

## ◆ end

const seekdir std::ios_base::end
| static inherited

Request a seek relative to the current end of the sequence.

Definition at line 532 of file ios_base.h.

Referenced by std::basic_filebuf< _CharT, _Traits >::open(), and std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff().

## ◆ eofbit

const iostate std::ios_base::eofbit
| static inherited

Indicates that an input operation reached the end of an input sequence.

Definition at line 460 of file ios_base.h.

Referenced by std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_iostream< char_type, traits_type >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::time_get< _CharT, _InIter >::get(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_iostream< char_type, traits_type >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, char_traits< _CharT > >::tellg(), std::basic_istream< _CharT, _Traits >::unget(), and std::ws().

## ◆ failbit

const iostate std::ios_base::failbit
| static inherited

Indicates that an input operation failed to read the expected characters, or that an output operation failed to generate the desired characters.

Definition at line 465 of file ios_base.h.

Referenced by std::basic_ostream< _CharT, _Traits >::sentry::sentry(), std::basic_fstream< char >::close(), std::basic_ifstream< char >::close(), std::basic_ofstream< char >::close(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_iostream< char_type, traits_type >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::time_get< _CharT, _InIter >::get(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::operator<<(), std::basic_iostream< char_type, traits_type >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_iostream< char_type, traits_type >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_ostream< _CharT, _Traits >::seekp(), and std::basic_ostream< _CharT, _Traits >::seekp().

## ◆ fixed

const fmtflags std::ios_base::fixed
| static inherited

Generate floating-point output in fixed-point notation.

Definition at line 387 of file ios_base.h.

Referenced by std::fixed(), and std::hexfloat().

## ◆ floatfield

const fmtflags std::ios_base::floatfield
| static inherited

A mask of scientific|fixed. Useful for the 2-arg form of `setf`.

Definition at line 439 of file ios_base.h.

Referenced by std::defaultfloat(), std::fixed(), std::hexfloat(), and std::scientific().

## ◆ goodbit

const iostate std::ios_base::goodbit
| static inherited

Indicates all is well.

Definition at line 468 of file ios_base.h.

Referenced by std::basic_istream< _CharT, _Traits >::sentry::sentry(), std::num_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::basic_ostream< _CharT, _Traits >::flush(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::basic_istream< _CharT, _Traits >::get(), std::time_get< _CharT, _InIter >::get(), std::basic_istream< _CharT, _Traits >::getline(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_istream< _CharT, _Traits >::ignore(), std::basic_iostream< char_type, traits_type >::operator<<(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_iostream< char_type, traits_type >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::basic_istream< _CharT, _Traits >::operator>>(), std::operator>>(), std::basic_ostream< _CharT, _Traits >::put(), std::basic_istream< _CharT, _Traits >::putback(), std::basic_istream< _CharT, _Traits >::readsome(), std::basic_iostream< char_type, traits_type >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::sync(), std::basic_istream< _CharT, char_traits< _CharT > >::tellg(), std::basic_istream< _CharT, _Traits >::unget(), and std::ws().

## ◆ hex

const fmtflags std::ios_base::hex
| static inherited

Converts integer input or generates integer output in hexadecimal base.

Definition at line 390 of file ios_base.h.

Referenced by std::num_get< _CharT, _InIter >::do_get(), std::num_put< _CharT, _OutIter >::do_put(), and std::hex().

## ◆ in

const openmode std::ios_base::in
| static inherited

Open for input. Default for `ifstream` and fstream.

Definition at line 498 of file ios_base.h.

Referenced by std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_ifstream< char >::basic_ifstream(), std::basic_istringstream< char >::basic_istringstream(), std::basic_stringbuf< char >::basic_stringbuf(), std::basic_stringstream< char >::basic_stringstream(), std::basic_filebuf< char_type, traits_type >::_M_set_buffer(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_ifstream< char >::open(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_filebuf< _CharT, _Traits >::pbackfail(), std::basic_streambuf< char_type, traits_type >::pubseekoff(), std::basic_streambuf< char_type, traits_type >::pubseekpos(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_istream< _CharT, _Traits >::seekg(), std::basic_streambuf< char_type, traits_type >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< char >::seekoff(), std::basic_streambuf< char_type, traits_type >::seekpos(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< char >::seekpos(), std::basic_filebuf< _CharT, _Traits >::showmanyc(), std::basic_stringbuf< char >::showmanyc(), std::basic_istream< _CharT, _Traits >::tellg(), std::basic_filebuf< _CharT, _Traits >::underflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::underflow(), and std::basic_filebuf< _CharT, _Traits >::xsgetn().

## ◆ internal

const fmtflags std::ios_base::internal
| static inherited

Adds fill characters at a designated internal point in certain generated output, or identical to `right` if no such point is designated.

Definition at line 395 of file ios_base.h.

Referenced by std::internal().

## ◆ left

const fmtflags std::ios_base::left
| static inherited

Adds fill characters on the right (final positions) of certain generated output. (I.e., the thing you print is flush left.).

Definition at line 399 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::left(), and std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator<<.

## ◆ oct

const fmtflags std::ios_base::oct
| static inherited

Converts integer input or generates integer output in octal base.

Definition at line 402 of file ios_base.h.

Referenced by std::oct().

## ◆ out

const openmode std::ios_base::out
| static inherited

Open for output. Default for `ofstream` and fstream.

Definition at line 501 of file ios_base.h.

Referenced by std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_fstream< char >::basic_fstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ofstream< char >::basic_ofstream(), std::basic_ostringstream< char >::basic_ostringstream(), std::basic_stringbuf< char >::basic_stringbuf(), std::basic_stringstream< char >::basic_stringstream(), std::basic_filebuf< char_type, traits_type >::_M_set_buffer(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_fstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_ofstream< char >::open(), std::basic_filebuf< _CharT, _Traits >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::overflow(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::pbackfail(), std::basic_streambuf< char_type, traits_type >::pubseekoff(), std::basic_streambuf< char_type, traits_type >::pubseekpos(), std::basic_streambuf< char_type, traits_type >::seekoff(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekoff(), std::basic_stringbuf< char >::seekoff(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_ostream< _CharT, _Traits >::seekp(), std::basic_streambuf< char_type, traits_type >::seekpos(), std::basic_stringbuf< _CharT, _Traits, _Alloc >::seekpos(), std::basic_stringbuf< char >::seekpos(), std::basic_ostream< _CharT, _Traits >::tellp(), and std::basic_filebuf< _CharT, _Traits >::xsputn().

## ◆ right

const fmtflags std::ios_base::right
| static inherited

Adds fill characters on the left (initial positions) of certain generated output. (I.e., the thing you print is flush right.).

Definition at line 406 of file ios_base.h.

Referenced by std::right().

## ◆ scientific

const fmtflags std::ios_base::scientific
| static inherited

Generates floating-point output in scientific notation.

Definition at line 409 of file ios_base.h.

Referenced by std::hexfloat(), and std::scientific().

## ◆ showbase

const fmtflags std::ios_base::showbase
| static inherited

Generates a prefix indicating the numeric base of generated integer output.

Definition at line 413 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::noshowbase(), and std::showbase().

## ◆ showpoint

const fmtflags std::ios_base::showpoint
| static inherited

Generates a decimal-point character unconditionally in generated floating-point output.

Definition at line 417 of file ios_base.h.

Referenced by std::noshowpoint(), and std::showpoint().

## ◆ showpos

const fmtflags std::ios_base::showpos
| static inherited

Generates a + sign in non-negative generated numeric output.

Definition at line 420 of file ios_base.h.

Referenced by std::noshowpos(), and std::showpos().

## ◆ skipws

const fmtflags std::ios_base::skipws
| static inherited

Skips leading white space before certain input operations.

Definition at line 423 of file ios_base.h.

Referenced by std::noskipws(), std::__detail::operator>>(), std::philox_engine< uint_fast32_t, 32, 4, 10, 0xCD9E8D57, 0x9E3779B9, 0xD2511F53, 0xBB67AE85 >::operator>>, and std::skipws().

## ◆ trunc

const openmode std::ios_base::trunc
| static inherited

Truncate an existing stream when opening. Default for `ofstream`.

Definition at line 504 of file ios_base.h.

## ◆ unitbuf

const fmtflags std::ios_base::unitbuf
| static inherited

Flushes output after each output operation.

Definition at line 426 of file ios_base.h.

Referenced by std::basic_ostream< _CharT, _Traits >::sentry::~sentry(), std::nounitbuf(), and std::unitbuf().

## ◆ uppercase

const fmtflags std::ios_base::uppercase
| static inherited

Replaces certain lowercase letters with their uppercase equivalents in generated output.

Definition at line 430 of file ios_base.h.

Referenced by std::num_put< _CharT, _OutIter >::do_put(), std::nouppercase(), and std::uppercase().

The documentation for this class was generated from the following files:

- basic_ios.h
- basic_ios.tcc